Index: pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c	(revision 1429)
+++ pjproject/trunk/pjsip-apps/src/py_pjsua/py_pjsua.c	(revision 1430)
@@ -3033,440 +1334,4 @@
 /* LIB ACCOUNT */
 
-/*
- * acc_config_Object
- * Acc Config
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */
-    int priority;	
-    PyObject * id;
-    PyObject * reg_uri;
-    int publish_enabled;
-    PyObject * force_contact;
-    unsigned proxy_cnt;
-    /*pj_str_t proxy[8];*/
-    PyListObject * proxy;
-    unsigned reg_timeout;
-    unsigned cred_count;
-    /*pjsip_cred_info cred_info[8];*/
-    PyListObject * cred_info;
-} acc_config_Object;
-
-
-/*
- * acc_config_dealloc
- * deletes a acc_config from memory
- */
-static void acc_config_dealloc(acc_config_Object* self)
-{
-    Py_XDECREF(self->id); 
-    Py_XDECREF(self->reg_uri);
-    Py_XDECREF(self->force_contact);	
-    Py_XDECREF(self->proxy);
-    Py_XDECREF(self->cred_info);
-    self->ob_type->tp_free((PyObject*)self);
-}
-
-
-/*
- * acc_config_new
- * constructor for acc_config object
- */
-static PyObject * acc_config_new(PyTypeObject *type, PyObject *args,
-                                    PyObject *kwds)
-{
-    acc_config_Object *self;
-
-    self = (acc_config_Object *)type->tp_alloc(type, 0);
-    if (self != NULL)
-    {
-        self->id = PyString_FromString("");
-        if (self->id == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-        self->reg_uri = PyString_FromString("");
-        if (self->reg_uri == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-        self->force_contact = PyString_FromString("");
-        if (self->force_contact == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-	self->proxy = (PyListObject *)PyList_New(8);
-	if (self->proxy == NULL)
-	{
-	    Py_DECREF(self);
-	    return NULL;
-	}
-	self->cred_info = (PyListObject *)PyList_New(8);
-	if (self->cred_info == NULL)
-	{
-	    Py_DECREF(self);
-	    return NULL;
-	}
-    }
-
-    return (PyObject *)self;
-}
-
-
-
-/*
- * acc_config_members
- */
-static PyMemberDef acc_config_members[] =
-{
-    {
-        "priority", T_INT, offsetof(acc_config_Object, priority), 0,
-        "Account priority, which is used to control the order of matching "
-        "incoming/outgoing requests. The higher the number means the higher "
-        "the priority is, and the account will be matched first. "
-    },
-    {
-        "id", T_OBJECT_EX,
-        offsetof(acc_config_Object, id), 0,
-        "The full SIP URL for the account. "
-        "The value can take name address or URL format, "
-        "and will look something like 'sip:account@serviceprovider'. "
-        "This field is mandatory."
-    },
-    {
-        "reg_uri", T_OBJECT_EX,
-        offsetof(acc_config_Object, reg_uri), 0,
-        "This is the URL to be put in the request URI for the registration, "
-        "and will look something like 'sip:serviceprovider'. "
-        "This field should be specified if registration is desired. "
-        "If the value is empty, no account registration will be performed. "
-    },
-    {
-        "publish_enabled", T_INT, 
-        offsetof(acc_config_Object, publish_enabled), 0,
-        "Publish presence? "
-    },
-    {
-        "force_contact", T_OBJECT_EX,
-        offsetof(acc_config_Object, force_contact), 0,
-        "Optional URI to be put as Contact for this account. "
-        "It is recommended that this field is left empty, "
-        "so that the value will be calculated automatically "
-        "based on the transport address. "
-    },
-    {
-        "proxy_cnt", T_INT, offsetof(acc_config_Object, proxy_cnt), 0,
-        "Number of proxies in the proxy array below. "
-    },
-    {
-        "proxy", T_OBJECT_EX,
-        offsetof(acc_config_Object, proxy), 0,
-        "Optional URI of the proxies to be visited for all outgoing requests "
-	"that are using this account (REGISTER, INVITE, etc). Application need "
-	"to specify these proxies if the service provider requires "
-	"that requests destined towards its network should go through certain "
-	"proxies first (for example, border controllers)."
-    },
-    {
-        "reg_timeout", T_INT, offsetof(acc_config_Object, reg_timeout), 0,
-        "Optional interval for registration, in seconds. "
-        "If the value is zero, default interval will be used "
-        "(PJSUA_REG_INTERVAL, 55 seconds). "
-    },
-    {
-        "cred_count", T_INT, offsetof(acc_config_Object, cred_count), 0,
-        "Number of credentials in the credential array. "
-    },
-    {
-        "cred_info", T_OBJECT_EX,
-        offsetof(acc_config_Object, cred_info), 0,
-        "Array of credentials. If registration is desired, normally there "
-	"should be at least one credential specified, to successfully "
-	"authenticate against the service provider. More credentials can "
-	"be specified, for example when the requests are expected to be "
-	"challenged by the proxies in the route set."
-    },
-    {NULL}  /* Sentinel */
-};
-
-
-
-
-/*
- * acc_config_Type
- */
-static PyTypeObject acc_config_Type =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                              /*ob_size*/
-    "py_pjsua.Acc_Config",      /*tp_name*/
-    sizeof(acc_config_Object),  /*tp_basicsize*/
-    0,                              /*tp_itemsize*/
-    (destructor)acc_config_dealloc,/*tp_dealloc*/
-    0,                              /*tp_print*/
-    0,                              /*tp_getattr*/
-    0,                              /*tp_setattr*/
-    0,                              /*tp_compare*/
-    0,                              /*tp_repr*/
-    0,                              /*tp_as_number*/
-    0,                              /*tp_as_sequence*/
-    0,                              /*tp_as_mapping*/
-    0,                              /*tp_hash */
-    0,                              /*tp_call*/
-    0,                              /*tp_str*/
-    0,                              /*tp_getattro*/
-    0,                              /*tp_setattro*/
-    0,                              /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "Acc Config objects",       /* tp_doc */
-    0,                              /* tp_traverse */
-    0,                              /* tp_clear */
-    0,                              /* tp_richcompare */
-    0,                              /* tp_weaklistoffset */
-    0,                              /* tp_iter */
-    0,                              /* tp_iternext */
-    0/*acc_config_methods*/,                              /* tp_methods */
-    acc_config_members,         /* tp_members */
-    0,                              /* tp_getset */
-    0,                              /* tp_base */
-    0,                              /* tp_dict */
-    0,                              /* tp_descr_get */
-    0,                              /* tp_descr_set */
-    0,                              /* tp_dictoffset */
-    0,                              /* tp_init */
-    0,                              /* tp_alloc */
-    acc_config_new,             /* tp_new */
-
-};
-
-/*
- * acc_info_Object
- * Acc Info
- */
-typedef struct
-{
-    PyObject_HEAD
-    /* Type-specific fields go here. */
-    int id;	
-    int is_default;
-    PyObject * acc_uri;
-    int has_registration;
-    int expires;
-    int status;
-    PyObject * status_text;
-    int online_status;	
-    char buf_[PJ_ERR_MSG_SIZE];
-} acc_info_Object;
-
-
-/*
- * acc_info_dealloc
- * deletes a acc_info from memory
- */
-static void acc_info_dealloc(acc_info_Object* self)
-{
-    Py_XDECREF(self->acc_uri); 
-    Py_XDECREF(self->status_text);	
-    self->ob_type->tp_free((PyObject*)self);
-}
-
-
-/*
- * acc_info_new
- * constructor for acc_info object
- */
-static PyObject * acc_info_new(PyTypeObject *type, PyObject *args,
-                                    PyObject *kwds)
-{
-    acc_info_Object *self;
-
-    self = (acc_info_Object *)type->tp_alloc(type, 0);
-    if (self != NULL)
-    {
-        self->acc_uri = PyString_FromString("");
-        if (self->acc_uri == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-		self->status_text = PyString_FromString("");
-        if (self->status_text == NULL)
-    	{
-            Py_DECREF(self);
-            return NULL;
-        }
-        
-    }
-
-    return (PyObject *)self;
-}
-
-static PyObject * acc_info_get_buf
-(acc_info_Object *self, PyObject * args)
-{
-    int idx;
-    char elmt;
-    if (!PyArg_ParseTuple(args,"i",&idx)) 
-    {
-        return NULL;
-    }
-    if ((idx >= 0) && (idx < PJ_ERR_MSG_SIZE)) 
-    {
-        elmt = self->buf_[idx];
-    } 
-    else
-    {
-        return NULL;
-    }
-    return PyString_FromStringAndSize(&elmt, 1);
-}
-
-static PyObject * acc_info_set_buf
-(acc_info_Object *self, PyObject * args)
-{
-    int idx;
-    PyObject * str;	
-    char * s;
-    if (!PyArg_ParseTuple(args,"iO",&idx, &str)) 
-    {
-        return NULL;
-    }
-    if ((idx >= 0) && (idx < PJ_ERR_MSG_SIZE)) 
-    {
-        s = PyString_AsString(str);
-        if (s[0]) 
-        {
-            self->buf_[idx] = s[0];
-        }	 
-	else 
-        {
-            return NULL;
-        }
-    } 
-    else
-    {
-        return NULL;
-    }
-    Py_INCREF(Py_None);
-    return Py_None;
-}
-
-static PyMethodDef acc_info_methods[] = {
-    {
-        "get_buf", (PyCFunction)acc_info_get_buf, METH_VARARGS,
-        "Return buf char at specified index"
-    },
-    {
-        "set_buf", (PyCFunction)acc_info_set_buf, METH_VARARGS,
-        "Set buf at specified index"
-    },
-	
-    {NULL}  /* Sentinel */
-};
-
-
-
-/*
- * acc_info_members
- */
-static PyMemberDef acc_info_members[] =
-{
-    {
-        "id", T_INT, offsetof(acc_info_Object, id), 0,
-        "The account ID."
-    },
-    {
-        "is_default", T_INT, offsetof(acc_info_Object, is_default), 0,
-        "Flag to indicate whether this is the default account. "
-    },
-    {
-        "acc_uri", T_OBJECT_EX,
-        offsetof(acc_info_Object, acc_uri), 0,
-        "Account URI"
-    },
-    {
-        "has_registration", T_INT, offsetof(acc_info_Object, has_registration),
-        0,
-        "Flag to tell whether this account has registration setting "
-        "(reg_uri is not empty)."
-    },
-    {
-        "expires", T_INT, offsetof(acc_info_Object, expires), 0,
-        "An up to date expiration interval for account registration session."
-    },
-    {
-        "status", T_INT, offsetof(acc_info_Object, status), 0,
-        "Last registration status code. If status code is zero, "
-        "the account is currently not registered. Any other value indicates "
-        "the SIP status code of the registration. "
-    },
-    {
-        "status_text", T_OBJECT_EX,
-        offsetof(acc_info_Object, status_text), 0,
-        "String describing the registration status."
-    },
-    {
-        "online_status", T_INT, offsetof(acc_info_Object, online_status), 0,
-        "Presence online status for this account. "
-    },
-    {NULL}  /* Sentinel */
-};
-
-
-
-
-/*
- * acc_info_Type
- */
-static PyTypeObject acc_info_Type =
-{
-    PyObject_HEAD_INIT(NULL)
-    0,                              /*ob_size*/
-    "py_pjsua.Acc_Info",      /*tp_name*/
-    sizeof(acc_info_Object),  /*tp_basicsize*/
-    0,                              /*tp_itemsize*/
-    (destructor)acc_info_dealloc,/*tp_dealloc*/
-    0,                              /*tp_print*/
-    0,                              /*tp_getattr*/
-    0,                              /*tp_setattr*/
-    0,                              /*tp_compare*/
-    0,                              /*tp_repr*/
-    0,                              /*tp_as_number*/
-    0,                              /*tp_as_sequence*/
-    0,                              /*tp_as_mapping*/
-    0,                              /*tp_hash */
-    0,                              /*tp_call*/
-    0,                              /*tp_str*/
-    0,                              /*tp_getattro*/
-    0,                              /*tp_setattro*/
-    0,                              /*tp_as_buffer*/
-    Py_TPFLAGS_DEFAULT,             /*tp_flags*/
-    "Acc Info objects",       /* tp_doc */
-    0,                              /* tp_traverse */
-    0,                              /* tp_clear */
-    0,                              /* tp_richcompare */
-    0,                              /* tp_weaklistoffset */
-    0,                              /* tp_iter */
-    0,                              /* tp_iternext */
-    acc_info_methods,                              /* tp_methods */
-    acc_info_members,         /* tp_members */
-    0,                              /* tp_getset */
-    0,                              /* tp_base */
-    0,                              /* tp_dict */
-    0,                              /* tp_descr_get */
-    0,                              /* tp_descr_set */
-    0,                              /* tp_dictoffset */
-    0,                              /* tp_init */
-    0,                              /* tp_alloc */
-    acc_info_new,             /* tp_new */
-
-};
-
-
 
 /*
@@ -3474,66 +1339,20 @@
  * !modified @ 051206
  */
-static PyObject *py_pjsua_acc_config_default
-(PyObject *pSelf, PyObject *pArgs)
-{
-    acc_config_Object *obj;
+static PyObject *py_pjsua_acc_config_default(PyObject *pSelf, PyObject *pArgs)
+{
+    PyObj_pjsua_acc_config *obj;
     pjsua_acc_config cfg;
-    int i;
-
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "")) {
+        return NULL;
+    }
+
     pjsua_acc_config_default(&cfg);
-    obj = (acc_config_Object *)acc_config_new(&acc_config_Type, NULL, NULL);
-    obj->cred_count = cfg.cred_count;
-    for (i = 0; i < PJSUA_MAX_ACC; i++) 
-    {
-        /*obj->cred_info[i] = cfg.cred_info[i];*/
-	int ret;
-	pjsip_cred_info_Object * ci = 
-	    (pjsip_cred_info_Object *)pjsip_cred_info_new
-	    (&pjsip_cred_info_Type,NULL,NULL);
-	ci->data = PyString_FromStringAndSize(cfg.cred_info[i].data.ptr, 
-	    cfg.cred_info[i].data.slen);
-	ci->realm = PyString_FromStringAndSize(cfg.cred_info[i].realm.ptr, 
-	    cfg.cred_info[i].realm.slen);
-	ci->scheme = PyString_FromStringAndSize(cfg.cred_info[i].scheme.ptr, 
-	    cfg.cred_info[i].scheme.slen);
-	ci->username = PyString_FromStringAndSize(cfg.cred_info[i].username.ptr, 
-	    cfg.cred_info[i].username.slen);
-	ci->data_type = cfg.cred_info[i].data_type;
-	ret = PyList_SetItem((PyObject *)obj->cred_info,i,(PyObject *)ci);
-	if (ret == -1) {
-	    return NULL;
-	}
-    }
-    
-    Py_XDECREF(obj->force_contact);
-    obj->force_contact = 
-        PyString_FromStringAndSize(cfg.force_contact.ptr, 
-        cfg.force_contact.slen);
-    obj->priority = cfg.priority;
-    Py_XDECREF(obj->id);
-    obj->id = 
-        PyString_FromStringAndSize(cfg.id.ptr, cfg.id.slen);
-    Py_XDECREF(obj->reg_uri);
-    obj->reg_uri = 
-        PyString_FromStringAndSize(cfg.reg_uri.ptr, cfg.reg_uri.slen);
-    obj->proxy_cnt = cfg.proxy_cnt;
-    for (i = 0; i < PJSUA_MAX_ACC; i++) 
-    {
-	PyObject * str;
-	int ret;
-        /*obj->proxy[i] = cfg.proxy[i];*/
-	str = PyString_FromStringAndSize(cfg.proxy[i].ptr, cfg.proxy[i].slen);
-	ret = PyList_SetItem((PyObject *)obj->proxy,i,str);
-	if (ret == -1) {
-	    return NULL;
-	}
-    }
-    obj->publish_enabled = cfg.publish_enabled;
-    obj->reg_timeout = cfg.reg_timeout;
-	
+    obj = (PyObj_pjsua_acc_config *)
+	  PyObj_pjsua_acc_config_new(&PyTyp_pjsua_acc_config, 
+				     NULL, NULL);
+    PyObj_pjsua_acc_config_import(obj, &cfg);
     return (PyObject *)obj;
 }
@@ -3542,12 +1361,14 @@
  * py_pjsua_acc_get_count
  */
-static PyObject *py_pjsua_acc_get_count
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_acc_get_count(PyObject *pSelf, PyObject *pArgs)
 {
     int count;
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "")) {
+        return NULL;
+    }
+
     count = pjsua_acc_get_count();
     return Py_BuildValue("i",count);
@@ -3557,16 +1378,16 @@
  * py_pjsua_acc_is_valid
  */
-static PyObject *py_pjsua_acc_is_valid
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_acc_is_valid(PyObject *pSelf, PyObject *pArgs)
 {    
     int id;
     int is_valid;
 
-    if (!PyArg_ParseTuple(pArgs, "i", &id))
-    {
-        return NULL;
-    }
-    is_valid = pjsua_acc_is_valid(id);
-	
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "i", &id)) {
+        return NULL;
+    }
+
+    is_valid = pjsua_acc_is_valid(id);	
     return Py_BuildValue("i", is_valid);
 }
@@ -3575,12 +1396,12 @@
  * py_pjsua_acc_set_default
  */
-static PyObject *py_pjsua_acc_set_default
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_acc_set_default(PyObject *pSelf, PyObject *pArgs)
 {    
     int id;
     int status;
 
-    if (!PyArg_ParseTuple(pArgs, "i", &id))
-    {
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "i", &id)) {
         return NULL;
     }
@@ -3593,13 +1414,14 @@
  * py_pjsua_acc_get_default
  */
-static PyObject *py_pjsua_acc_get_default
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_acc_get_default(PyObject *pSelf, PyObject *pArgs)
 {    
     int id;
 	
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
-        return NULL;
-    }
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "")) {
+        return NULL;
+    }
+
     id = pjsua_acc_get_default();
 	
@@ -3611,66 +1433,31 @@
  * !modified @ 051206
  */
-static PyObject *py_pjsua_acc_add
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_acc_add(PyObject *pSelf, PyObject *pArgs)
 {    
     int is_default;
     PyObject * acObj;
-    acc_config_Object * ac;
-    pjsua_acc_config cfg;
-    
-    int p_acc_id;
+    PyObj_pjsua_acc_config * ac;
+    int acc_id;
     int status;
-    int i;
-
-    if (!PyArg_ParseTuple(pArgs, "Oi", &acObj, &is_default))
-    {
-        return NULL;
-    }
-
-    pjsua_acc_config_default(&cfg);
-    if (acObj != Py_None)
-    {
-        ac = (acc_config_Object *)acObj;
-        cfg.cred_count = ac->cred_count;
-        for (i = 0; i < PJSUA_MAX_ACC; i++) 
-	{
-            /*cfg.cred_info[i] = ac->cred_info[i];*/
-            pjsip_cred_info_Object * ci = (pjsip_cred_info_Object *)
-				PyList_GetItem((PyObject *)ac->cred_info,i);
-            cfg.cred_info[i].data.ptr = PyString_AsString(ci->data);
-            cfg.cred_info[i].data.slen = strlen(PyString_AsString(ci->data));
-            cfg.cred_info[i].realm.ptr = PyString_AsString(ci->realm);
-            cfg.cred_info[i].realm.slen = strlen(PyString_AsString(ci->realm));
-            cfg.cred_info[i].scheme.ptr = PyString_AsString(ci->scheme);
-            cfg.cred_info[i].scheme.slen = strlen
-				(PyString_AsString(ci->scheme));
-            cfg.cred_info[i].username.ptr = PyString_AsString(ci->username);
-            cfg.cred_info[i].username.slen = strlen
-				(PyString_AsString(ci->username));
-            cfg.cred_info[i].data_type = ci->data_type;
-	}
-        cfg.force_contact.ptr = PyString_AsString(ac->force_contact);
-        cfg.force_contact.slen = strlen(PyString_AsString(ac->force_contact));
-        cfg.id.ptr = PyString_AsString(ac->id);
-        cfg.id.slen = strlen(PyString_AsString(ac->id));
-        cfg.priority = ac->priority;
-        for (i = 0; i < PJSUA_MAX_ACC; i++) 
-	{
-            /*cfg.proxy[i] = ac->proxy[i];*/
-            cfg.proxy[i].ptr = PyString_AsString
-				(PyList_GetItem((PyObject *)ac->proxy,i));
-	}
-        cfg.proxy_cnt = ac->proxy_cnt;
-        cfg.publish_enabled = ac->publish_enabled;
-        cfg.reg_timeout = ac->reg_timeout;
-        cfg.reg_uri.ptr = PyString_AsString(ac->reg_uri);
-        cfg.reg_uri.slen = strlen(PyString_AsString(ac->reg_uri));
-    
-        status = pjsua_acc_add(&cfg, is_default, &p_acc_id);
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "Oi", &acObj, &is_default)) {
+        return NULL;
+    }
+    
+    if (acObj != Py_None) {
+	pjsua_acc_config cfg;
+
+	pjsua_acc_config_default(&cfg);
+        ac = (PyObj_pjsua_acc_config *)acObj;
+        PyObj_pjsua_acc_config_export(&cfg, ac);
+        status = pjsua_acc_add(&cfg, is_default, &acc_id);
     } else {
-        status = pjsua_acc_add(NULL, is_default, &p_acc_id);
-    }
-    
-    return Py_BuildValue("ii", status, p_acc_id);
+        status = PJ_EINVAL;
+	acc_id = PJSUA_INVALID_ID;
+    }
+    
+    return Py_BuildValue("ii", status, acc_id);
 }
 
@@ -3679,16 +1466,14 @@
  * !modified @ 051206
  */
-static PyObject *py_pjsua_acc_add_local
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_acc_add_local(PyObject *pSelf, PyObject *pArgs)
 {    
     int is_default;
     int tid;
-    
     int p_acc_id;
     int status;
 	
-
-    if (!PyArg_ParseTuple(pArgs, "ii", &tid, &is_default))
-    {
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "ii", &tid, &is_default)) {
         return NULL;
     }
@@ -3703,9 +1488,10 @@
  * py_pjsua_acc_del
  */
-static PyObject *py_pjsua_acc_del
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_acc_del(PyObject *pSelf, PyObject *pArgs)
 {    
     int acc_id;
     int status;
+
+    PJ_UNUSED_ARG(pSelf);
 
     if (!PyArg_ParseTuple(pArgs, "i", &acc_id))
@@ -3722,57 +1508,27 @@
  * py_pjsua_acc_modify
  */
-static PyObject *py_pjsua_acc_modify
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_acc_modify(PyObject *pSelf, PyObject *pArgs)
 {    	
     PyObject * acObj;
-    acc_config_Object * ac;
-    pjsua_acc_config cfg;	
+    PyObj_pjsua_acc_config * ac;
     int acc_id;
     int status;
-    int i;
-
-    if (!PyArg_ParseTuple(pArgs, "iO", &acc_id, &acObj))
-    {
-        return NULL;
-    }
-    if (acObj != Py_None)
-    {
-        ac = (acc_config_Object *)acObj;
-        cfg.cred_count = ac->cred_count;
-        for (i = 0; i < PJSUA_MAX_ACC; i++) 
-	{
-            /*cfg.cred_info[i] = ac->cred_info[i];*/
-            pjsip_cred_info_Object * ci = (pjsip_cred_info_Object *)
-				PyList_GetItem((PyObject *)ac->cred_info,i);
-            cfg.cred_info[i].data.ptr = PyString_AsString(ci->data);
-            cfg.cred_info[i].data.slen = strlen(PyString_AsString(ci->data));
-            cfg.cred_info[i].realm.ptr = PyString_AsString(ci->realm);
-            cfg.cred_info[i].realm.slen = strlen(PyString_AsString(ci->realm));
-            cfg.cred_info[i].scheme.ptr = PyString_AsString(ci->scheme);
-            cfg.cred_info[i].scheme.slen = strlen
-				(PyString_AsString(ci->scheme));
-            cfg.cred_info[i].username.ptr = PyString_AsString(ci->username);
-            cfg.cred_info[i].username.slen = strlen
-				(PyString_AsString(ci->username));
-	}
-        cfg.force_contact.ptr = PyString_AsString(ac->force_contact);
-        cfg.force_contact.slen = strlen(PyString_AsString(ac->force_contact));
-        cfg.id.ptr = PyString_AsString(ac->id);
-        cfg.id.slen = strlen(PyString_AsString(ac->id));
-        cfg.priority = ac->priority;
-        for (i = 0; i < PJSUA_MAX_ACC; i++) 
-	{
-            /*cfg.proxy[i] = ac->proxy[i];*/
-             cfg.proxy[i].ptr = PyString_AsString
-				(PyList_GetItem((PyObject *)ac->proxy,i));
-	}
-        cfg.proxy_cnt = ac->proxy_cnt;
-        cfg.publish_enabled = ac->publish_enabled;
-        cfg.reg_timeout = ac->reg_timeout;
-        cfg.reg_uri.ptr = PyString_AsString(ac->reg_uri);
-        cfg.reg_uri.slen = strlen(PyString_AsString(ac->reg_uri));	
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "iO", &acc_id, &acObj)) {
+        return NULL;
+    }
+
+    if (acObj != Py_None) {
+	pjsua_acc_config cfg;	
+
+	pjsua_acc_config_default(&cfg);
+        ac = (PyObj_pjsua_acc_config *)acObj;
+        PyObj_pjsua_acc_config_export(&cfg, ac);
+
         status = pjsua_acc_modify(acc_id, &cfg);
     } else {
-        status = pjsua_acc_modify(acc_id, NULL);
+        status = PJ_EINVAL;
     }
     return Py_BuildValue("i", status);
@@ -3782,6 +1538,6 @@
  * py_pjsua_acc_set_online_status
  */
-static PyObject *py_pjsua_acc_set_online_status
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_acc_set_online_status(PyObject *pSelf, 
+						PyObject *pArgs)
 {    
     int is_online;	
@@ -3789,6 +1545,7 @@
     int status;	
 
-    if (!PyArg_ParseTuple(pArgs, "ii", &acc_id, &is_online))
-    {
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "ii", &acc_id, &is_online)) {
         return NULL;
     }
@@ -3800,8 +1557,37 @@
 
 /*
+ * py_pjsua_acc_set_online_status2
+ */
+static PyObject *py_pjsua_acc_set_online_status2(PyObject *pSelf, 
+						 PyObject *pArgs)
+{    
+    int is_online;	
+    int acc_id;
+    int activity_id;
+    const char *activity_text;
+    pjrpid_element rpid;
+    pj_status_t status;	
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "iiis", &acc_id, &is_online,
+			  &activity_id, &activity_text)) {
+        return NULL;
+    }
+
+    pj_bzero(&rpid, sizeof(rpid));
+    rpid.activity = activity_id;
+    rpid.note = pj_str((char*)activity_text);
+
+    status = pjsua_acc_set_online_status2(acc_id, is_online, &rpid);
+
+    return Py_BuildValue("i", status);
+}
+
+/*
  * py_pjsua_acc_set_registration
  */
-static PyObject *py_pjsua_acc_set_registration
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_acc_set_registration(PyObject *pSelf, 
+					       PyObject *pArgs)
 {    
     int renew;	
@@ -3809,6 +1595,7 @@
     int status;	
 
-    if (!PyArg_ParseTuple(pArgs, "ii", &acc_id, &renew))
-    {
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "ii", &acc_id, &renew)) {
         return NULL;
     }
@@ -3823,39 +1610,22 @@
  * !modified @ 051206
  */
-static PyObject *py_pjsua_acc_get_info
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_acc_get_info(PyObject *pSelf, PyObject *pArgs)
 {    	
     int acc_id;
-    acc_info_Object * obj;
+    PyObj_pjsua_acc_info * obj;
     pjsua_acc_info info;
     int status;	
-    int i;
-
-    if (!PyArg_ParseTuple(pArgs, "i", &acc_id))
-    {
-        return NULL;
-    }
-	
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "i", &acc_id)) {
+        return NULL;
+    }
     
     status = pjsua_acc_get_info(acc_id, &info);
-    if (status == PJ_SUCCESS) 
-    {
-	obj = (acc_info_Object *)acc_info_new(&acc_info_Type,NULL, NULL);
-        obj->acc_uri =
-            PyString_FromStringAndSize(info.acc_uri.ptr, 
-            info.acc_uri.slen);
-        for (i = 0; i < PJ_ERR_MSG_SIZE; i++) 
-	{
-            obj->buf_[i] = info.buf_[i];
-	}
-        obj->expires = info.expires;
-        obj->has_registration = info.has_registration;
-        obj->id = info.id;
-        obj->is_default = info.is_default;
-        obj->online_status = info.online_status;
-        obj->status = info.status;
-        obj->status_text =
-	    PyString_FromStringAndSize(info.status_text.ptr, 
-	    info.status_text.slen);
+    if (status == PJ_SUCCESS) {
+	obj = (PyObj_pjsua_acc_info *)
+	    PyObj_pjsua_acc_info_new(&PyTyp_pjsua_acc_info,NULL, NULL);
+	PyObj_pjsua_acc_info_import(obj, &info);
         return Py_BuildValue("O", obj);
     } else {
@@ -3876,4 +1646,7 @@
     pjsua_acc_id id[PJSUA_MAX_ACC];
     unsigned c, i;
+
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, ""))
     {
@@ -3905,9 +1678,10 @@
     pj_status_t status;
     PyObject *list;
-    
     pjsua_acc_info info[PJSUA_MAX_ACC];
     unsigned c, i;
-    if (!PyArg_ParseTuple(pArgs, ""))
-    {
+
+    PJ_UNUSED_ARG(pSelf);
+
+    if (!PyArg_ParseTuple(pArgs, "")) {
         return NULL;
     }	
@@ -3917,28 +1691,12 @@
     
     list = PyList_New(c);
-    for (i = 0; i < c; i++) 
-    {
-        int ret;
-        int j;
-        acc_info_Object *obj;
-        obj = (acc_info_Object *)acc_info_new(&acc_info_Type,NULL,NULL);
-        obj->acc_uri = PyString_FromStringAndSize
-	    (info[i].acc_uri.ptr, info[i].acc_uri.slen);
-        for(j = 0; j < PJ_ERR_MSG_SIZE; j++) 
-	{
-            obj->buf_[j] = info[i].buf_[j];
-	}
-        obj->expires = info[i].expires;
-        obj->has_registration = info[i].has_registration;
-        obj->id = info[i].id;
-        obj->is_default = info[i].is_default;
-        obj->online_status = info[i].online_status;
-        obj->status = info[i].status;
-        obj->status_text = PyString_FromStringAndSize(info[i].status_text.ptr,
-	    info[i].status_text.slen);
-        ret = PyList_SetItem(list, i, (PyObject *)obj);
-        if (ret == -1) {
-            return NULL;
-        }
+    for (i = 0; i < c; i++) {
+        PyObj_pjsua_acc_info *obj;
+        obj = (PyObj_pjsua_acc_info *)
+	      PyObj_pjsua_acc_info_new(&PyTyp_pjsua_acc_info, NULL, NULL);
+
+	PyObj_pjsua_acc_info_import(obj, &info[i]);
+
+        PyList_SetItem(list, i, (PyObject *)obj);
     }
     
@@ -3949,11 +1707,12 @@
  * py_pjsua_acc_find_for_outgoing
  */
-static PyObject *py_pjsua_acc_find_for_outgoing
-(PyObject *pSelf, PyObject *pArgs)
-{    
-	
+static PyObject *py_pjsua_acc_find_for_outgoing(PyObject *pSelf, 
+						PyObject *pArgs)
+{    	
     int acc_id;	
     PyObject * url;
     pj_str_t str;
+
+    PJ_UNUSED_ARG(pSelf);
 
     if (!PyArg_ParseTuple(pArgs, "O", &url))
@@ -3972,12 +1731,14 @@
  * py_pjsua_acc_find_for_incoming
  */
-static PyObject *py_pjsua_acc_find_for_incoming
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_acc_find_for_incoming(PyObject *pSelf, 
+						PyObject *pArgs)
 {    	
     int acc_id;	
     PyObject * tmpObj;
-    pjsip_rx_data_Object * obj;
+    PyObj_pjsip_rx_data * obj;
     pjsip_rx_data * rdata;
 
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, "O", &tmpObj))
     {
@@ -3986,5 +1747,5 @@
     if (tmpObj != Py_None)
     {
-        obj = (pjsip_rx_data_Object *)tmpObj;
+        obj = (PyObj_pjsip_rx_data *)tmpObj;
         rdata = obj->rdata;
         acc_id = pjsua_acc_find_for_incoming(rdata);
@@ -3999,11 +1760,11 @@
  * !modified @ 061206
  */
-static PyObject *py_pjsua_acc_create_uac_contact
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_acc_create_uac_contact(PyObject *pSelf, 
+						 PyObject *pArgs)
 {    	
     int status;
     int acc_id;
     PyObject * pObj;
-    pj_pool_Object * p;
+    PyObj_pj_pool * p;
     pj_pool_t * pool;
     PyObject * strc;
@@ -4012,4 +1773,6 @@
     pj_str_t uri;
 
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, "OiO", &pObj, &acc_id, &stru))
     {
@@ -4018,5 +1781,5 @@
     if (pObj != Py_None)
     {
-        p = (pj_pool_Object *)pObj;
+        p = (PyObj_pj_pool *)pObj;
         pool = p->pool;    
         uri.ptr = PyString_AsString(stru);
@@ -4035,18 +1798,20 @@
  * !modified @ 061206
  */
-static PyObject *py_pjsua_acc_create_uas_contact
-(PyObject *pSelf, PyObject *pArgs)
+static PyObject *py_pjsua_acc_create_uas_contact(PyObject *pSelf, 
+						 PyObject *pArgs)
 {    	
     int status;
     int acc_id;	
     PyObject * pObj;
-    pj_pool_Object * p;
+    PyObj_pj_pool * p;
     pj_pool_t * pool;
     PyObject * strc;
     pj_str_t contact;
     PyObject * rObj;
-    pjsip_rx_data_Object * objr;
+    PyObj_pjsip_rx_data * objr;
     pjsip_rx_data * rdata;
 
+    PJ_UNUSED_ARG(pSelf);
+
     if (!PyArg_ParseTuple(pArgs, "OiO", &pObj, &acc_id, &rObj))
     {
@@ -4055,5 +1820,5 @@
     if (pObj != Py_None)
     {
-        p = (pj_pool_Object *)pObj;
+        p = (PyObj_pj_pool *)pObj;
         pool = p->pool;
     } else {
